<?php

use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

require $_SERVER['DOCUMENT_ROOT'] . "/idealpatios2/contact/PHPMailer-master/src/Exception.php";
require $_SERVER['DOCUMENT_ROOT'] . "/idealpatios2/contact/PHPMailer-master/src/SMTP.php";
require $_SERVER['DOCUMENT_ROOT'] . "/idealpatios2/contact/PHPMailer-master/src/PHPMailer.php";
require_once $_SERVER['DOCUMENT_ROOT'] . "/idealpatios2/contact/dompdf/autoload.inc.php";

use Dompdf\Dompdf;
use Dompdf\Options;

class Mailer {

    protected array $to;
    protected array $bcc;
    protected string $from;
    protected string $subject;
    protected string $body;
    protected array $photos;

    public function __construct($config)
    {
        $this->to = $config['TO_ADDRESSES'];
        $this->bcc = $config['BCC_ADDRESSES'];
        $this->from = $config['FROM_ADDRESS'];
        $this->subject = $config['SUBJECT'];
    }

    public function setBody($params) {
        $body = "";
        foreach ($params as $key=>$value) {
            if ($key !== "g-recaptcha-response" && $key !== 'photos') {
                $body .= ucfirst($key) . ": " . $value . " </br></br>";
            }

            if ($key === 'photos') {
                $this->photos = $value;
            }
        }

        $this->body = $body;
    }

    public function getBody($html = true) {

        return $html ? $this->body : strip_tags($this->body);
    }

    public function send() {
        try {
            $mail = new PHPMailer(true);


            // Only set to true if using custom SMTP
            if (false) {
                $mail->isSMTP();
                $mail->Host = '127.0.0.1';
                $mail->SMTPAuth = false;
                $mail->Port = 2525;
            }

            $mail->setFrom($this->from);

            foreach($this->to as $recipient) {
                $mail->addAddress($recipient);
            }

            foreach ($this->bcc as $recipient) {
                $mail->addBCC($recipient);
            }

            $mail->Subject = $this->subject;
            $mail->isHTML();

            $mail->Body = $this->body;
            $mail->AltBody = strip_tags($this->body);

            if (!empty($this->photos)) {
                foreach ($this->photos as $photo) {
                    if (!empty($photo)) {
                        $mail->addAttachment($photo);
                    }
                }
            }

            $mail->send();
        } catch (Exception $e) {
            print_r($e);
        }
    }
}
